---------------------------------------------------------------------------------------
-------------------------------------- 2022.09.23 -------------------------------------
--[[
___.echo(chaine [, nomCouleur, nomChat]) -- 1ere fenetre de chat si non spécifiée
___.echoChatAppl(chaine, showVersionBooleen, colorNameOrHexa) -- echo avec nom et version addon

___.getTxtColor(chaine [, colorNameOrHexa]) -- renvoit la chaine formattée avec la couleur ("SYSTEM" par défaut)

___.testPrint(chaine) -- echo seulement si mode DEBUG activé (nécessite addonVar et getVar() !

___.echoTable(tbl [, comm, niveauUnique, prefixe, nivIndent]) -- pour DEV
___.echoDebug(valeur [, comm]) -- pour DEV

___.getColor(colornameOrHexaOrRGBtable, outputFormatStr)
	-- convertit la couleur passée au format de sortie voulu : "hexa" || "table" || "rgb" (defaut)
	-- colornameOrHexaOrRGBtable : nom couleur (chaine), ou couleur hexa (chaine), ou table {r,g,b}
	
	.showHiliteFrame(frame, "green", 0.8) -- DEV
--]]

---------------------------------------------------------------------------------------
---------------------------------------- DIVERS ---------------------------------------

function Emlib.valSiNul(value, defaultValue)
	local defaultValue = defaultValue or "NIL"
	if (value == nil) then return defaultValue else return value end
end

function Emlib.videSiNul(valeur)
	if (valeur == nil) then return "" else return valeur end
end

function Emlib.nilSiNul(valeur)
	if (valeur == nil) then return "NIL" else return valeur end
end

function Emlib.zeroSiNul(value, numberOnly) -- avec numberOnly à true : renvoit 0 si value n'est pas un nombre
	if (numberOnly == nil) then numberOnly = false end
	if (value == nil) then
		return 0
	else
		if (numberOnly == true) then
			if (tonumber(value) == nil) then
				return 0
			else
				return tonumber(value)
			end
		else
			return value
		end
	end
end

function Emlib.isEmpty(variable) -- renvoit true si la variable ou la table passee est vide ou nil
	if (type(variable) == "table") then
		local next = next;
		return (next(variable) == nil);
	else
		return (variable == nil or variable == "");
	end;
end

function Emlib.isTrue(value, acceptYes) -- accepte les entiers 0 et 1, et aussi les chaines avec "acceptYes" à TRUE
	if (value ~= nil) then
		if (type(value) == "boolean") then
			return value
		else
			local tbl = {1, "1", "true"}
			if (acceptYes == true) then tbl = {1, "1", "true", "y", "yes", "on"} end
			return (tContains(tbl, string.lower(tostring(value))))
		end
	else
		return false
	end
end

function Emlib.attribueBinaire(valeur)
	if (valeur == 1 or valeur == "1") then return (1); else return (0) end
end

function Emlib.getBindedKey(nomCommande)
	----- renvoit le NOM de la touche associee a la commande passee : non encore disponible sur VARIABLE_LOADED !
	----- renvoit NIL s'il n'y a pas de touche associee a la commande passee (chaine entre guillemets)
	if (type(nomCommande) == "string") then
		local key1,key2 = GetBindingKey(nomCommande)
		if (key1 == nil and key2 == nil) then return nil end
		if (key1 ~= nil) then return key1 else return key2 end
	else
		return "ERROR"
	end
end

function Emlib.testPrint(str) -- nécessite addonVar et getVar() !
	if (Emlib.debug()) then print(Emlib.getTxtColor(Emlib.getVar("name").." @ "..Emlib.getHorodatage().." ", "red")..Emlib.getTxtColor(Emlib.nilSiNul(str), "orange")) end
end

function Emlib.printTest(str) -- alias
	Emlib.testPrint(str)
end

function Emlib.devPrint(str) -- alias
	Emlib.testPrint(str)
end

function Emlib.printDev(str) -- alias
	Emlib.testPrint(str)
end

function Emlib.getSeconds(msBoolean) -- serverTime en seconds. si msBoolean true :  renvoit les ms en décimales
	local now = GetServerTime()
	if (Emlib.isTrue(msBoolean)) then
		return (now + math.fmod(GetTime(), 1))
	else
		return now
	end
end

function Emlib.getHorodatage(fullDateBoolean) -- formatage de l'horodatage
	if (Emlib.isTrue(fullDateBoolean)) then
		return date("%Y.%m.%d %H:%M:%S", GetServerTime())
	else
		return date("%H:%M:%S", GetServerTime())
	end
end

function Emlib.getApplName(showVersionBooleen) -- nécessite addonVar et getVar() !
	local strTemp = Emlib.getVar("name") or "???"
	if (Emlib.isTrue(showVersionBooleen)) then strTemp = strTemp.." "..Emlib.getVersion(false) end
	return "|cFF".. Emlib.getVar("chatColor")..strTemp.."|r"
end

function Emlib.getVersion(numberFormatBoolean) -- nécessite addonVar et getVar() !
	-- avec numberFormatBooleen TRUE : renvoit la valeur numérique de la version
	-- avec numberFormatBooleen FALSE : renvoit une chaine et le tag "X-PublicVersion"
	if (Emlib.isTrue(numberFormatBooleen)) then
		return Emlib.strToNumber(Emlib.getVar("version"))
	else
		local publicVersion
		publicVersion = Emlib.videSiNul(GetAddOnMetadata(Emlib.getVar("name"), "X-PublicVersion"))
		return (Emlib.getVar("version")..publicVersion)
	end
end

function Emlib.getStuffPath(elementName, inStuffFolderBoolean) -- nécessite addonVar et getVar() !
	local path = "Interface\\AddOns\\"..Emlib.getVar("name").."\\"
	if (Emlib.isTrue(inStuffFolderBoolean)) then path = path.."stuff\\" end
	return path..elementName
end

function Emlib.echoChatAppl(str, showVersionBooleen, color)
	-- affiche la str dans la 1ere fenetre de chat VISIBLE avec le nom (et éventuellement la version) de l'addon
	-- color : tout type de couleur accepeté ("SYSTEM" par défaut)
	local strTemp = Emlib.getApplName(showVersionBooleen)
	Emlib.echoWindow(strTemp.." "..Emlib.getTxtColor(str, color), nil, nil)
end

function Emlib.isRetail() -- renvoit true si WoW "normal", et false pour toutes autres versions
	return (WOW_PROJECT_ID == 1)
end

function Emlib.isClassic() -- renvoit true si Classic(s)
	return (WOW_PROJECT_ID ~= WOW_PROJECT_MAINLINE)
end

function Emlib.wowMasterVersion() -- renvoit le numéro générique de version de WoW (8 pour BFA, 9 pour SL)
	local wowversion, wowbuild, wowdate, wowtocversion = GetBuildInfo()
	return floor(wowtocversion / 10000)
end

function Emlib.executeCmd(cmdStr, isMacroBoolean, noPrintErrorBoolean) -- return "", or error string
	-- execute une /macro ou commande (plusieurs lignes possible)
	local cmdStr = cmdStr or ""
	local tbl = {strsplit("\n", cmdStr)}
	
	local function executeString(str) -- return "", or error string
		local str = str or ""
		local func, errorMessage = loadstring(str)
		if (not func) then
			return "slash command LUA error #59000."
		else
			local success, errorMessage = pcall(func)
			if (not success) then
				return "slash command error #59001."
			else
				return ""
			end
		end
	end
	
	local resultStr = ""
	for i, strLine in ipairs(tbl) do
		if (resultStr ~= "") then break end
		if (Emlib.isTrue(isMacroBoolean)) then
			--------------------------- macro ("/" needed)
			if (string.sub(strLine, 1, 1) ~= "/") then strLine = "/"..strLine end
			if (string.sub(strLine, 1, 5) == "/run ") then
				strLine = string.sub(strLine, 6)
				resultStr = executeString(strLine)
			elseif (string.sub(strLine, 1, 8) == "/script ") then
				strLine = string.sub(strLine, 9)
				resultStr = executeString(strLine)
			else
				DEFAULT_CHAT_FRAME.editBox:SetText(strLine) -- sent to Chat Box
				ChatEdit_SendText(DEFAULT_CHAT_FRAME.editBox,0)
			end
		else
			--------------------------- command ("/" not valid)
			if (string.sub(strLine, 1, 1) == "/") then strLine = string.sub(strLine, 2) end -- delete char 1
			resultStr = executeString(strLine)
		end
	end
	
	if ((resultStr ~= "") and (not noPrintErrorBoolean)) then Emlib.echoChatAppl(resultStr, false, "red") end
	return resultStr
end

function Emlib.executeMacro(macroStr) -- conservé pour rétro-compatibilité
	Emlib.executeCmd(macroStr, true)
end

function Emlib.invertColor(color)
	-- renvoit sous forme r,g,b les valeurs inversées de la couleur passée (toutes formes acceptées)
	local r, g, b = Emlib.getColor(color, "rgb")
	---------------
	if ((r > 0.4 and r < 0.6) and (g > 0.4 and g < 0.6) and (b > 0.4 and b < 0.6)) then -- gris moyen
		return 0.86, 0.84, 0.49 -- jaune pale
	else
		return Emlib.inversionValeur(r), Emlib.inversionValeur(g), Emlib.inversionValeur(b)
	end
end

function Emlib.flash(texture, delay, alpha) -- effet visuel
	local delay = tonumber(delay) or 0.3 -- seconde
	
	local savedAlpha = texture:GetAlpha()
	local alpha = tonumber(alpha) or Emlib.inversionValeur(savedAlpha)
	texture:SetAlpha(alpha)
	C_Timer.After(delay, function()
		texture:SetAlpha(savedAlpha)
	end)
end

function Emlib.soundTest(idSound) -- pour dev
	if (type(idSound) == "number") then
		print("Playing sound ID", idSound)
		PlaySound(idSound)
	else
		print("Invalid sound ID", idSound)
	end
end

---------------------------------------------------------------------------------------
-------------------------------------- CONVERSION -------------------------------------

function Emlib.strToNumber(chaine) -- renvoit 0 par defaut, alors que tonumber() renvoit nil
	local valTmp = tonumber(chaine, 10)
	if (valTmp == nil) then return 0 else return valTmp end
end

function Emlib.booleanToBin(boolean)
	return (boolean == 1)
end

function Emlib.booleanToInt(boolean) -- accepte les valeurs binaires
	local boolean = boolean or false
	if (boolean == true or boolean == 1) then return 1 else return 0 end
end

function Emlib.booleanToStr(boolean)
	local boolean = boolean or false
	return tostring(boolean)
end

function Emlib.booleanToEN(boolean) -- accepte les valeurs binaires
	local boolean = boolean or false
	if (boolean == true or boolean == 1) then return "YES" else return "NO" end
end

function Emlib.booleanToON(boolean) -- accepte les valeurs binaires
	local boolean = boolean or false
	if (boolean == true or boolean == 1) then return "ON" else return "OFF" end
end

---------------------------------------------------------------------------------------
------------------------------------- ARITHMETIQUE ------------------------------------

function Emlib.inversionValeur(value) -- switch 0 - > 1 et 0 -> 1
	local varType = type(value)
	if (varType == "number") then
		return math.abs(value - 1)
	elseif (varType == "boolean") then
		return not value
	else
		return value
	end
end

function Emlib.round(number, numDecimalPlaces, toStringBoolean)
	local number = number or 0
	local numDecimalPlaces = numDecimalPlaces or 0
	if (Emlib.isTrue(toStringBoolean)) then
		return (string.format("%."..numDecimalPlaces.."f", number)) -- résultat en string
	else
		return tonumber(string.format("%."..numDecimalPlaces.."f", number)) -- résultat en nombre
	end
end

function Emlib.nombreParDefaut(nombre, defautVal, borneInf, borneSup) -- bornes optionnelles
	local nombre = tonumber(nombre)
	local defautVal = defautVal or 0
	
	if (nombre == nil) then return defautVal end
	if (borneInf ~= nil and nombre < borneInf) then return defautVal end
	if (borneSup ~= nil and nombre > borneSup) then return defautVal end
	return nombre
end

function Emlib.entierParDefaut(nombre, defautVal, borneInf, borneSup) -- ENTIER (bornes optionnelles)
	local nombre = tonumber(nombre)
	local defautVal = defautVal or 0
	
	if (nombre == nil) then return defautVal end
	if (borneInf ~= nil and nombre < borneInf) then return defautVal end
	if (borneSup ~= nil and nombre > borneSup) then return defautVal end
	return floor(nombre)
end

---------------------------------------------------------------------------------------
--------------------------------------- CHAINES ---------------------------------------

function Emlib.kwote(chaine)
	return ("\""..Emlib.videSiNul(chaine).."\"")
end

function Emlib.simpleKwote(chaine) -- guillemets simples
	return ("'"..Emlib.videSiNul(chaine).."'")
end

function Emlib.truncStr(str, maxChars, strReplaceCR) -- si strReplaceCR = nil : pas de remplacement de CR
	local str = str or ""
	local maxChars = tonumber(maxChars) or 0
	if (strReplaceCR ~= nil) then str = string.gsub(str, "\n", strReplaceCR) end
	if (string.len(str) > maxChars) then return (string.sub(str, 0, maxChars - 1).."…") else return str end
end

function Emlib.getItem(chaine, delim, numeroItem)
	-- renvoit l' "élément" de la chaine passée, séparé par delim (avec la numérotation "littéraire")
	-- renvoit la chaine entière si pas de delim dans la chaine
	-- numeroItem : accepte les chaines '1, first, premier, last, dernier' (premier item par défaut)
	
	if (chaine == nil) then return "" end
	local delim = delim or " "
	local numeroItem = numeroItem or 1
	
	local tbl = {strsplit(delim, chaine, 0)} -- no limit
	local tailleTbl = #(tbl)
	if (tailleTbl > 1) then
		if (numeroItem == '1' or numeroItem == 'first' or numeroItem == 'premier') then
			numeroItem = 1
		elseif (numeroItem == 'last' or numeroItem == 'dernier') then
			numeroItem = tailleTbl
		else
			numeroItem = tonumber(numeroItem) or 1
		end
		return tbl[min(tailleTbl, max(1, numeroItem))]
	else
		return chaine
	end
end

function Emlib.getLastItem(chaine, delim) -- raccourci pour .getItem()
	-- renvoit le dernier "élément" de la chaine passée, séparé par delim (ou la chaine entière si pas de delim dans la chaine)
	return Emlib.getItem(chaine, delim, 'last')
end

function Emlib.explode(str, delim, maxItems) -- conservé pour rétro-compatibilité
	-- si maxItems = 0 ou nil, la fcn renverra la table complete
	if (str == nil) then return {} end
	local maxItems = tonumber(maxItems) -- nil possible
	local delim = delim or ","
	
	return {strsplit(delim, str, maxItems)} -- table
end

function Emlib.implode(tbl, delim) -- identique a la fcn de PHP (renvoit une chaine)
	if (type(tbl) == "table") then
		if (not Emlib.isEmpty(tbl)) then
			if (delim == nil) then delim = "" end
			local tailleDelim = strlen(delim)
			local chaine = ""
			for index, value in pairs(tbl) do
				chaine = chaine..value..delim
			end
			tbl = string.sub(chaine, 1, -(tailleDelim + 1)) -- suppression dernier delim
		end
	end
	return tbl
end

---------------------------------------------------------------------------------------
---------------------------------------- TABLES ---------------------------------------

function Emlib.sortTable(tableOr, cle, sens, genre) -- ATTENTION : à utilser comme fcn (ne modifie pas l'original)
	----- trie la table passee par une cle
	----- sens peut etre "A" (ascendant, defaut) ou "D" (descendant)
	----- genre peut etre "N" (numerique, defaut) ou "A" (alphabetique)
	local sens = sens or "A"
	sens = string.upper(string.sub(sens,1,1))
	local genre = genre or "N"
	genre = string.upper(string.sub(genre,1,1))
	
	local tbl = {}
	for i in ipairs(tableOr) do
		table.insert(tbl, i)
	end
	
	if (sens == "D") then
		if (genre == "A") then
			table.sort(tbl, function(a, b) return string.lower(tableOr[a][cle]) > string.lower(tableOr[b][cle]) end)
		else -- numerique par defaut
			table.sort(tbl, function(a, b) return tableOr[a][cle] > tableOr[b][cle] end)
		end
	else -- ascendant par defaut
		if (genre == "A") then
			table.sort(tbl, function(a, b) return string.lower(tableOr[a][cle]) < string.lower(tableOr[b][cle]) end)
		else -- numerique par defaut
			table.sort(tbl, function(a, b) return tableOr[a][cle] < tableOr[b][cle] end)
		end
	end
	
	for i in ipairs(tbl) do
		tbl[i] = tableOr[tbl[i]]
	end
	
	return tbl
end

function Emlib.copyTable(tbl, metaIdentique)
	----- effectue une vraie copie d'une table et non un clonage
	----- si metaIdentique vaut TRUE, les 2 tables partageront la meme metatable
	
	local lookup_table = {}
	local function copyTableRec(tbl)
		if type(tbl) ~= "table" then
			return tbl
		elseif lookup_table[tbl] then
			return lookup_table[tbl]
		end
		local new_table = {}
		lookup_table[tbl] = new_table
		for index, value in pairs(tbl) do
			new_table[copyTableRec(index)] = copyTableRec(value)
		end
		
		if (metaIdentique) then
			return setmetatable(new_table, getmetatable(tbl))
		else
			return setmetatable(new_table, copyTableRec(getmetatable(tbl)))
		end;
	end
	return copyTableRec(tbl)
end

function Emlib.isInTable(tbl, valeur, caseNonSensitive)
	----- renvoit la cle (numerique ou associative) de la table passée dont l'element vaut la valeur passee
	----- renvoit NIL si aucun element ne vaut la valeur passee
	----- identique à tcontains() mais fonctionne aussi pour une table associative
	if (type(tbl) == "table") then
		if (caseNonSensitive) then
			for key, value in pairs(tbl) do
				if (strlower(value) == strlower(valeur)) then return key end
			end
		else
			for key, value in pairs(tbl) do
				if (value == valeur) then return key end
			end
		end
	end
	return nil
end

function Emlib.tableKeyDiff(tblReference, tblToCheck, level) -- renvoit nil si les deux tables possèdent les mêmes clés (attention à l'ordre des params !)
	local level = level or ""
	if (type(tblReference) == "table" and type(tblToCheck) == "table") then
		for key, value in pairs(tblReference) do
			if (tblToCheck[key] == nil) then return level.."."..key end
			if (type(value) == "table") then
				local w = Emlib.tableKeyDiff(value, tblToCheck[key], key)
				if (w ~= nil) then return level.."."..w end
			end
		end
	else
		return "not a table"
	end
end

function Emlib.getEnd(tbl) -- renvoit le dernier élément d'une table , ou nil
	if (tbl == nil or type(tbl) ~= "table") then return nil else return tbl[#tbl] end
end

---------------------------------------------------------------------------------------
-------------------------------- CONVERSIONS COULEURS ---------------------------------

function Emlib.getColor(colornameOrHexaOrRGBtable, outputFormatStr)
	-- convertit la couleur passée au format de sortie voulu : outputFormatStr = "hexa" || "table" || "rgb" (defaut)
	-- colornameOrHexaOrRGBtable : nom couleur (chaine), ou couleur hexa (chaine), ou table {r,g,b}
	
	local outputFormatStr = outputFormatStr or "rgb"
	outputFormatStr = strlower(outputFormatStr)
	local r, g, b = 0.5, 0.5, 0.5 -- default
	local arg = colornameOrHexaOrRGBtable or {r, g, b}
	---------------------------------------------- définition couleur passée
	if (type(arg) == "table") then
		------------------------------ table {r,g,b} passée
		if (#(arg) >= 3) then r, g, b = arg[1], arg[2], arg[3] end
	elseif (type(arg) == "string") then
		------------------------------ chaine passée
		local tableColor = Emlib.getPredefinedColor(arg, true) -- retour sous forme de table
		if (tableColor ~= nil) then
			------------- chaine passée = nom couleur prédéfini
			r, g, b = tableColor[1], tableColor[2], tableColor[3]
		else
			------------- chaine passée est une couleur en hexa valide ?
			r, g, b = Emlib.HexToRGBPerc(arg)
			if (r == nil) then
				r, g, b = 0.5, 0.5, 0.5 -- chaine passée non hexa valide : retour au défaut
			end
		end
	end
	---------------------------------------------- retour
	if (outputFormatStr == "hexa") then
		return Emlib.RGBPercToHex(r, g, b)
	elseif (outputFormatStr == "table") then
		return {r, g, b}
	else
		return  r, g, b
	end
end

function Emlib.colornameToHexa(colorNameOrHexa) -- convertit la couleur passée en forme hexa (6 digits)
	-- colorNameOrHexa peut etre un nom de couleur prédéfinie, ou une chaine hexa (inchangée), ou nil ("SYSTEM" par défaut)
	------------------------------------ default : "SYSTEM"
	local tblChat = ChatTypeInfo["SYSTEM"]
	local sysColor = Emlib.RGBPercToHex(tblChat["r"], tblChat["g"], tblChat["b"])
	------------------------------------
	if (colorNameOrHexa == nil or colorNameOrHexa == "") then
		return sysColor
	else
		local hexaColor = Emlib.getPredefinedColor(colorNameOrHexa, false)
		if (hexaColor ~= nil) then
			---------------------------- nom couleur trouvée
			return hexaColor
		else
			---------------------------- chaine passée est une couleur en hexa valide ?
			local r, g, b = Emlib.HexToRGBPerc(colorNameOrHexa)
			if (r ~= nil) then return colorNameOrHexa end
		end
	end
	return sysColor -- defaut
end
function Emlib.getHexColor(colorNameOrHexa) -- pour rétro-compatibilité
	return Emlib.colornameToHexa(colorNameOrHexa)
end

function Emlib.RGBPercToHex(r, g, b) -- convertit les composantes couleurs passées en chaine hexa (ou nil)
	r = r <= 1 and r >= 0 and r or 0
	g = g <= 1 and g >= 0 and g or 0
	b = b <= 1 and b >= 0 and b or 0
	return string.format("%02x%02x%02x", r*255, g*255, b*255)
end

function Emlib.HexToRGBPerc(hexStr) -- convertit la couleur hexa passée (chaine) en décimal RGB (ou nil)
	local hexStr = hexStr or "CCCCCC"
	if (string.sub(hexStr, 1, 1) == "#") then hexStr = string.sub(hexStr, 2) end
	local rhex, ghex, bhex = string.sub(hexStr, 1, 2), string.sub(hexStr, 3, 4), string.sub(hexStr, 5, 6)
	if ((tonumber(rhex, 16) ~= nil) and (tonumber(ghex, 16) ~= nil) and (tonumber(bhex, 16) ~= nil)) then
		return (tonumber(rhex, 16)/255), (tonumber(ghex, 16)/255), (tonumber(bhex, 16)/255)
	else
		return nil, nil, nil
	end
end

function Emlib.getPredefinedColor(englishColorName, resultTableBoolean)
	-- renvoit la chaine hexa ou la table {r,g,b}, ou nil, d'une couleur prédéfinie
	-- accepte "system" comme nom de couleur (defaut)
	local englishColorName = englishColorName or "system"
	englishColorName = strlower(englishColorName)
	
	local tblChat = ChatTypeInfo["SYSTEM"]
	local tbl = {
		["red"] = {"CC0303", {0.8, 0.01, 0.01}}, -- DIM_RED_FONT_COLOR
		["orange"] = {"CBA934", {0.8,0.66,0.2}},
		["yellow"] = {"FFD100", {1, 0.82, 0}}, -- NORMAL_FONT_COLOR (yellow)
		["green"] = {"17FF17", {0.09, 1, 0.09}}, -- GREEN_FONT_COLOR
		["aqua"] = {"55EBF7", {0.33,0.92,0.97}},
		["blue"] = {"00BFF2", {0, 0.75, 0.95}}, -- BLUE_FONT_COLOR
		["purple"] = {"A84DF2", {0.66,0.3,0.95}},
		["white"] = {"FFFFFF", {1,1,1}},
		["cream"] = {"EDDEBF", {0.93,0.87,0.75}},
		["grey"] = {"AAAAAA", {0.5, 0.5, 0.5}}, -- GRAY_FONT_COLOR
		["gray"] = {"AAAAAA", {0.5, 0.5, 0.5}}, -- GRAY_FONT_COLOR
		["silver"] = {"D9D9D9", {0.85,0.85,0.85}},
		["dark"] = {"444444", {0.27,0.27,0.27}},
		["black"] = {"111111", {0.07,0.07,0.07}},
		["system"] = {Emlib.RGBPercToHex(tblChat["r"], tblChat["g"], tblChat["b"]), {tblChat["r"], tblChat["g"], tblChat["b"]}},
	}
	
	if (tbl[englishColorName] ~= nil) then -- nom couleur trouvée
		if (Emlib.isTrue(resultTableBoolean)) then return tbl[englishColorName][2] else return tbl[englishColorName][1] end
	else
		return nil
	end
end

function Emlib.getRGBColor(colorNameOrHexa)
	-- raccourci : renvoit les valeurs r, g, b d'une couleur passée sous forme de table
	local r, g, b = Emlib.HexToRGBPerc(Emlib.colornameToHexa(colorNameOrHexa))
	return {r, g, b}
end

---------------------------------------------------------------------------------------
--------------------------------------- GROUP (IG) ------------------------------------

function Emlib.inParty(noRaid) -- renvoit true si en "vrai" groupe (party OU raid)
	-- noRaid (true par défaut) permet de ne pas compter les groupes d'un raid
	if (Emlib.isEmpty(noRaid)) then noRaid = true end -- ne pas compter les groupes de raid
	
	if (noRaid) then
		return (IsInGroup(LE_PARTY_CATEGORY_HOME) and not IsInRaid()) -- filtre pour "vrai" groupe (non instance)
	else
		return IsInGroup(LE_PARTY_CATEGORY_HOME) -- filtre pour "vrai" groupe (non instance)
	end
end

function Emlib.inRaid() -- renvoit true si en raid seulement (pas en party ni instance)
	return (IsInRaid() and not Emlib.inInstance())
end

function Emlib.inInstance() -- renvoit true si en instance (LFG/LFR) : remplacement de Emlib.inInstance() dont les résultats ne sont pas fiables
	return IsInGroup(LE_PARTY_CATEGORY_INSTANCE)
end

function Emlib.isGrouped(noInstance) -- renvoit true si groupé (raid OU party OU instance)
	-- noInstance (true par défaut) permet de ne pas compter les groupes d'instance
	if (Emlib.isEmpty(noInstance)) then noInstance = true end -- ne pas compter les instances
	
	if (noInstance) then
		return (GetNumGroupMembers(LE_PARTY_CATEGORY_HOME) > 0) -- filtre instance actif
	else
		return (GetNumGroupMembers() > 0) -- raid, groupe et instance
	end
end

---------------------------------------------------------------------------------------
----------------------------------- SLASH-COMMANDES -----------------------------------

function Emlib.slashCmd_Lib(argStr, execLevel) -- argStr est toute la chaine d'arguments (à parser)
	-- pour tester une commande : Emlib.slashCmd_Lib("commande slash telle que tapée dans chat")
	local execLevel = execLevel or 1 -- pour infinite loop
	local taille = 0
	local tblParams = {strsplit(" ", argStr, 2)} -- 2 params maxi
	local passedCmd = tblParams[1] or nil
	local passedArg = tblParams[2] or nil
	
	local function slashCmd_subTableSearch(passedCmd, subTbl)
		for i, value in ipairs(subTbl) do
			if (tContains(value.cmd, passedCmd)) then return value end
		end
		return nil
	end
	
	local tblCmds = Emlib.slashCmd_getList(passedArg) -- passer passedArg pour exécuter fcn définie dans la liste des cmds
	if (not Emlib.isEmpty(passedCmd)) then
		passedCmd = strlower(passedCmd)
	else
		passedCmd = tblCmds.DEFAULTCMD
	end
--print("slashCmd_Lib() : passedCmd=", passedCmd, "---passedArg=", passedArg, "---execLevel=", execLevel)--/////

	------------------------------------ recherche commande passée dans "macro", puis "user" et enfin "dev"
	local cmdTbl
	if (tblCmds["macro"] ~= nil) then cmdTbl = slashCmd_subTableSearch(passedCmd, tblCmds.macro) end
	if (cmdTbl == nil) then cmdTbl = slashCmd_subTableSearch(passedCmd, tblCmds.user) end
	if (cmdTbl == nil) then cmdTbl = slashCmd_subTableSearch(passedCmd, tblCmds.dev) end
	
	if (cmdTbl == nil) then
		------------- commande non trouvée
		if (type(execLevel) ~= "number" or execLevel > 1) then
			Emlib.echoChatAppl("unknown command.", true, "red")
		else
--print("slashCmd_Lib() : DEFAULTCMD=", tblCmds.DEFAULTCMD)--/////
			Emlib.slashCmd_Lib(tblCmds.DEFAULTCMD, 2)
		end
	else
		cmdTbl.func(passedArg)
	end
end

function Emlib.slashCmd_showList(dontPrint) -- affichage de la liste des slash-commands : nécessite addonVar et getVar() !
	local tblCmds = Emlib.slashCmd_getList()
	local cmdInfos = {}
	
	local function formatLineCmd(tbl, comm)
		local comm = comm or ""
		local tbl = tbl or {}
		
		local addonCmd = Emlib.getVar("slashCmd")
		if (addonCmd == nil) then addonCmd = Emlib.videSiNul(Emlib.getVar("name")) end
		addonCmd = "/"..addonCmd.." "
		if (comm ~= "") then addonCmd = comm.."   "..addonCmd end
		
		addonCmd = addonCmd..tbl.cmd[1]
		if (not Emlib.isEmpty(tbl.type)) then addonCmd = addonCmd.." ["..tbl.type.."]" end
		if (not Emlib.isEmpty(tbl.label)) then addonCmd = addonCmd.." : "..tbl.label end

		return addonCmd
	end
	------------------------- construction avec cmds user
	for i, data in ipairs(tblCmds.user) do
		table.insert(cmdInfos, formatLineCmd(data, comm))
	end
	------------------------- ajout éventuel des cmds dev
	if (Emlib.debug()) then
		for i, data in ipairs(tblCmds.dev) do
			table.insert(cmdInfos, formatLineCmd(data, "DEV"))
		end
	end
	------------------------- sortie
	if (Emlib.isTrue(dontPrint)) then -- pour UI config (si existe)
		local helpStr = ""
		for index, value in ipairs(cmdInfos) do
			helpStr = helpStr..value.."\n"
		end
		return (string.sub(helpStr, 1, -2))
	else
		Emlib.echoChatAppl(Emlib.getLocal("Available commands:"), true, "grey")
		for key,value in pairs(cmdInfos) do
			Emlib.echoChat("      "..value.."", "SYSTEM", true)
		end
	end
end

---------------------------------------------------------------------------------------
------------------------------------------ XML ----------------------------------------

function Emlib.setEscapeClosable(frame) -- le frame doit avoir un nom !
	if (frame:GetName() ~= nil) then tinsert(UISpecialFrames, frame:GetName()) end
end

function Emlib.setFontStyle(fontString, fontNameOrPath, fontSize, color, outlineBoolean, alpha) -- modifie une fontString
	-- fontName = "arial", ou chemin police, ou "friz" par defaut
	-- color : tout type admis : rgb, nom ou tableRGB ("yellow" par défaut)
	-- .GetFontColor() dispo
	if (fontString ~= nil) then
		local alpha = alpha or 1
		local color = color or Emlib.getColor("yellow", "table") -- jaune standard
		local fontSize = tonumber(fontSize) or 12
		local fontNameOrPath = fontNameOrPath or "friz"
		
		local style = "OUTLINE, MONOCHROME"
		if (not outlineBoolean) then style = "" end
		
		if ((string.find(fontNameOrPath, ".ttf", 1, true) ~= nil) or (string.find(fontNameOrPath, ".TTF", 1, true) ~= nil)) then
			--------------- chemin font
			fontString:SetFont(fontNameOrPath, fontSize, style)
		else
			--------------- nom (font built-in)
			fontNameOrPath = strlower(fontNameOrPath)
			if (fontNameOrPath == "arial") then
				fontString:SetFont("Fonts\\ARIALN.TTF", fontSize, style)
			else
				fontString:SetFont("Fonts\\FRIZQT__.TTF", fontSize, style) -- défaut
			end
		end
		
		local r, g, b = Emlib.getColor(color, "rgb")
		fontString:SetTextColor(r, g, b, alpha)
		------------------------------ script
		fontString.r = r; fontString.g = g; fontString.b = b; 
		fontString.GetFontColor = function(self)
			return {self.r, self.g, self.b}
		end
	end
end

function Emlib.createRectButton(btnName, parentFrame, labelStr, width, height) -- renvoit un frame/button
	-- créé une bouton basique, à colorier, à placer et à scripter
	-- :GetText() et :SetText() dispos
	-- .text (et.fontString) dispo (pour application style fontString)
	local button = CreateFrame("Button", btnName, parentFrame)
	button:SetSize(width, height)
	
	local fontString = button:CreateFontString(btnName.."_Text", "OVERLAY", "GameFontNormal")
	fontString:SetPoint("CENTER", 0, 1)
	fontString:SetJustifyH("CENTER")
	fontString:SetText(labelStr)
	
	button.text = fontString -- pour handler changement style
	button.fontString = fontString -- alias
	button.GetText = function() return fontString:GetText() end
	button.SetText = function(self, str) fontString:SetText(str) end

	return button
end

function Emlib.createStandardButton(btnName, parentFrame, labelStr, width) -- renvoit un frame/button
	-- créé une bouton Standard (rouge) à placer et à scripter
	-- :GetText() et :SetText() dispos
	local button = CreateFrame("Button", btnName, parentFrame, "UIPanelButtonTemplate")
	button:SetSize(tonumber(width) or 100, 25)
	button:SetText(labelStr)
	
	return button
end

function Emlib.createStandardCheckBox(btnName, parentFrame, labelStr, labelColor) -- renvoit un frame/checkbox
	-- créé une checkbox compatible wow10 avec son label cliquable
	-- :GetChecked() et :SetChecked() dispos
	-- :GetText() et :SetText() dispos (label)
	-- .text (ou .fontString) et .text:GetWidth() dispo (pour application style fontString au label)
	local labelPadding = 5
	-------------------------- case à cocher
	local checkBoxTemplate = "SettingsCheckBoxTemplate" -- wow10
	if (not DoesTemplateExist(checkBoxTemplate)) then checkBoxTemplate = "OptionsCheckButtonTemplate" end
	local checkBox = CreateFrame("CheckButton", btnName, parentFrame, checkBoxTemplate)
	-------------------------- label
	local fontString
	if (checkBoxTemplate == "SettingsCheckBoxTemplate") then
		fontString = checkBox:CreateFontString(btnName.."_Text", "OVERLAY", "GameFontNormal")
		fontString:SetPoint("LEFT", checkBox, "RIGHT", labelPadding, 0)
		fontString:SetJustifyH("LEFT")
		fontString:SetWordWrap(false)
		checkBox.text = fontString
	else
		checkBox.text = _G[btnName.."Text"]
	end
	checkBox.fontString = fontString -- alias
	checkBox.text:SetText(labelStr)
	checkBox:SetHitRectInsets(0, -checkBox.text:GetStringWidth() + 4, 0, 0) -- normalisation du label cliquable
	-------------------------------------------- fcns
	checkBox.GetText = function() return checkBox.text:GetText() end
	checkBox.SetText = function(self, str) checkBox.text:SetText(str) end
	------------------------- 
	return checkBox
end

function Emlib.createRectCheckBox(btnName, parentFrame, btnHeight, labelStr, bkColor, borderColor, bkAlpha, labelColor, labelSize) -- renvoit un button/checkbox
	-- créé une checkbox RECTANGULAIRE avec son label cliquable
	-- DEPENDANCE : .setColoredFrame()
	-- :GetChecked() et :SetChecked() dispos
	-- :GetText() et :SetText() dispos (label)
	-- .text ou .font dispo (pour application style fontString au label)
	-- .GetBackgroundColor() ou .r, .g, .b et .alpha dispos
	-- .GetBorderColor() ou .br, .bg, .bb et .balpha dispos
	-- :GetWidth() dispo
	-- ATTENTION : le changement de check doit se faire par script ed l'objet créé : OBJ:SetChecked(not OBJ:GetChecked())
	local labelPadding = 6
	-------------------------------------------- button (ensemble pour gestion "OnClick")
	local btn = CreateFrame("Button", btnName, parentFrame or UIParent)
	-------------------------- case à cocher
	------------- case
	local checkBox = CreateFrame("Frame", nil, btn)
	checkBox:SetPoint("LEFT", btn, "LEFT", 0)
	local btnHeight = tonumber(btnHeight) or 20
	checkBox:SetSize(btnHeight, btnHeight)
	Emlib.setColoredFrame(checkBox, bkColor, borderColor, 1, bkAlpha)
	------------- coche
	local checkString = checkBox:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	checkString:SetPoint("CENTER", checkBox, 0)
	checkString:SetJustifyH("CENTER"); checkString:SetJustifyV("CENTER")
	Emlib.setFontStyle(checkString, "Arial", labelSize or 12, "yellow", false, 1)
	-------------------------- label
	local labelString = checkBox:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	labelString:SetPoint("LEFT", checkBox, "RIGHT", labelPadding, 0)
	labelString:SetJustifyH("LEFT")
	labelString:SetWordWrap(false)
	labelString:SetText(labelStr)
	Emlib.setFontStyle(labelString, "Arial", labelSize or 12, labelColor or "yellow", false, 1)
	local strWidth = labelString:GetStringWidth()
	checkBox:SetHitRectInsets(0, -strWidth + 4, 0, 0) -- normalisation du label cliquable
	-------------------------------------------- fcns
	btn.text = labelString -- pour appel stylage
	btn.font = labelString -- alias
	btn.labelString = labelString -- alias
	btn.GetText = function() return labelString:GetText() end
	btn.SetText = function(self, str) labelString:SetText(str) end
	
	btn.SetChecked = function(self, boolean)
		btn.checked = Emlib.isTrue(boolean)
		if (btn.checked) then checkString:SetText("X") else checkString:SetText("") end
	end
	btn.GetChecked = function(self)
		return (btn.checked or false)
	end
	-------------------------------------------- scripts
	--NON : les changements de check doit se faire dans le script associé à l'ensemble créé
	-------------------------------------------- 
	btn:SetSize(btnHeight + labelPadding + strWidth, btnHeight)
	--------------------------------------------
	bkColor = Emlib.getColor(bkColor, "table")
	btn.r = bkColor[1]; btn.g = bkColor[2]; btn.b = bkColor[3]; btn.alpha = bkAlpha
	borderColor = Emlib.getColor(borderColor, "table")
	btn.br = borderColor[1]; btn.bg = borderColor[2]; btn.bb = borderColor[3]; btn.balpha = 1
	btn.GetBackgroundColor = function(self)
		return {self.r, self.g, self.b}
	end
	btn.GetBorderColor = function(self)
		return {self.br, self.bg, self.bb}
	end
	--------------------------------------------
	return btn
end

function Emlib.createSlider(sliderName, parent, width, minValue, maxValue, showMinMaxTblOrBoolean, verticalBoolean)
	-- slider horizontal.    :GetValue() et :SetValue() dispos
	local slider = CreateFrame("Slider", sliderName, parent, "OptionsSliderTemplate")
	local minValue = minValue or 0
	local maxValue = maxValue or 0
	
	slider:SetWidth(tonumber(width))
	slider:SetHeight(20)
	if (verticalBoolean) then
		slider:SetOrientation("VERTICAL")
	else
		slider:SetOrientation("HORIZONTAL")
	end
	slider:SetMinMaxValues(minValue, maxValue)
	
	if (type(showMinMaxTblOrBoolean) == "table") then
		_G[sliderName.."Low"]:SetText(showMinMaxTblOrBoolean[1])
		_G[sliderName.."High"]:SetText(showMinMaxTblOrBoolean[2])
	elseif (type(showMinMaxTblOrBoolean) == "boolean") then
		if (showMinMaxTblOrBoolean) then
			_G[sliderName.."Low"]:SetText(minValue)
			_G[sliderName.."High"]:SetText(maxValue)
		else
			_G[sliderName.."Low"]:SetText("")
			_G[sliderName.."High"]:SetText("")
		end
	else
		_G[sliderName.."Low"]:SetText("")
		_G[sliderName.."High"]:SetText("")
	end
	--if (tooltipStr ~= nil) then slider.tooltipText = tooltipStr end

	slider.SetText = function(self, value)
		_G[sliderName.."Text"]:SetText(value)
	end
	
	return slider
end

function Emlib.createTextFrame(frameName, parent, width, texte, padding) -- créé un frame
	-- créé un frame auto-adaptable en hauteur, suivant le texte contenu
	-- :GetText() et :SetText() dispos
	-- :SetPadding() dispo
	-- .font (ou .fontString) dispos pour le stylage
	--[[ usage :
		local frame = Emlib.createTextFrame(nil, parent, frameWidth, "The Text", 10)
		frame:SetPoint("TOPLEFT", frameFrame, "BOTTOMLEFT", 0, -20)
		-- Emlib.setFontStyle(frame.font, nil, 10, "#CCCCCC", false, nil)
		-- Emlib.setRoundBorderedFrame(frame, nil, nil, nil)
	--]]
	local frame = CreateFrame("Frame", frameName, parent, BackdropTemplateMixin and "BackdropTemplate")
	frame:SetWidth(tonumber(width) or 100)
	----------------------- fontString
	frame.fontString = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	frame.fontString:SetJustifyV("TOP")
	frame.fontString:SetJustifyH("LEFT")
	frame.font = frame.fontString -- alias
	-------------- padding
	frame.SetPadding = function(self, padding)
		padding = tonumber(padding) or 0
		frame.fontString:SetWidth(floor(frame:GetWidth()) - (padding * 2))
		frame:SetHeight(frame.fontString:GetHeight() + (padding * 2))
		frame.fontString:SetPoint("TOPLEFT", frame, "TOPLEFT", padding, -padding)
	end
	frame:SetPadding(tonumber(padding) or 0)
	----------------------- texte
	frame.text = frame.fontString:GetText()
	frame.GetText = function() return frame.text end
	frame.SetText = function(self, str)
		frame.fontString:SetText(str)
		frame:SetHeight(frame.fontString:GetHeight() + (padding * 2))
	end
	frame:SetText(texte)
	-----------------------
	return frame
end

function Emlib.setRoundBorderedFrame(frame, bkColor, bkAlpha, borderColor) -- modifie un frame
	-- ajoute une bordure arrondie texturée (type "tooltip") à un frame
	-- laisser les 3 derniers paramètres à nil pour une tooltip grise et discrète
	-- .GetBackgroundColor() ou .r, .g, .b et .alpha dispos
	-- .GetBorderColor() ou .br, .bg, .bb et .balpha dispos
	if (frame ~= nil) then
		if (not frame.SetBackdrop) then Mixin(frame, BackdropTemplateMixin) end
		
		frame.backdrop = { -- backdrop definition
			bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true,
			tileSize = 16,
			edgeSize = 16,
			insets = {left = 4, right = 4, top = 4, bottom = 2},
		}
		frame:SetBackdrop(frame.backdrop)
		
		local color = borderColor or {0.5, 0.5, 0.5}
		color = Emlib.getColor(color, "table")
		frame:SetBackdropBorderColor(color[1], color[2], color[3])
		
		local bkAlpha = tonumber(bkAlpha) or 0.5
		color = bkColor or {0.3, 0.3, 0.3}
		color = Emlib.getColor(color, "table")
		frame:SetBackdropColor(color[1], color[2], color[3], bkAlpha)
		------------------------
		frame.r = color[1]; frame.g = color[2]; frame.b = color[3]; frame.alpha = bkAlpha
		borderColor = Emlib.getColor(borderColor, "table")
		frame.br = borderColor[1]; frame.bg = borderColor[2]; frame.bb = borderColor[3]; frame.balpha = 1
		frame.GetBackgroundColor = function(self)
			return {self.r, self.g, self.b}
		end
		frame.GetBorderColor = function(self)
			return {self.br, self.bg, self.bb}
		end
	end
end

function Emlib.createRectBorder(frame, borderWidth, borderColor, borderAlpha) -- alias
	Emlib.createBorder(frame, borderWidth, borderColor, borderAlpha)
end

function Emlib.createBorder(frame, borderWidth, borderColor, borderAlpha) -- modifie un frame
	-- dessine ou modifie une bordure RECTANGULAIRE autour du frame passé
	-- borderColor : nom couleur, ou couleur hexa, ou table {r, g, b}
	-- appel pour créer ou *modifier* une bordure existante : .createBorder(myFrame, 1, "blue", 0.8)
	-- pour supprimer une bordure existante : passer 0 en borderWidth
	-- .GetBorderColor() ou .br, .bg, .bb et .balpha dispos
	-- .GetBorderWidth(), ou .borderWidth dispo
	if (frame ~= nil) then
		local borderWidth = tonumber(borderWidth) or 0
		if (borderColor ~= nil) then
			local borderAlpha = tonumber(borderAlpha) or 1
			borderColor = Emlib.getColor(borderColor, "table") -- conversion couleur en table rgb
			if (not frame.borders) then
				----------------------------------- création bordures
				frame.borders = {}
				for i = 1, 4 do
					frame.borders[i] = frame:CreateLine(nil, "BACKGROUND", nil, 0)
					local l = frame.borders[i]
					l:SetThickness(borderWidth)
					l:SetColorTexture(borderColor[1], borderColor[2], borderColor[3], borderAlpha)
					if (i == 1) then
						l:SetStartPoint("TOPLEFT", 0, 0)
						l:SetEndPoint("TOPRIGHT", 0, 0)
					elseif (i == 2) then
						l:SetStartPoint("TOPRIGHT", 0, 0)
						l:SetEndPoint("BOTTOMRIGHT", 0, 0)
					elseif (i == 3) then
						l:SetStartPoint("BOTTOMRIGHT", 0, 0)
						l:SetEndPoint("BOTTOMLEFT", 0, 0)
					else
						l:SetStartPoint("BOTTOMLEFT", 0, 0)
						l:SetEndPoint("TOPLEFT", 0, 0)
					end
				end
			else
				----------------------------------- modification couleur et largeur bordures
				for i = 1, 4 do
					frame.borders[i]:SetThickness(borderWidth)
					frame.borders[i]:SetColorTexture(borderColor[1], borderColor[2], borderColor[3], borderAlpha)
				end
			end
			--------------------------------------- scripts
			frame.borderWidth = borderWidth
			frame.br = borderColor[1]; frame.bg = borderColor[2]; frame.bb = borderColor[3]; frame.balpha = borderAlpha
			frame.GetBorderColor = function(self)
				return {self.br, self.bg, self.bb}
			end
			frame.GetBorderWidth = function(self)
				return self.borderWidth
			end
		end
		frame.br = nil; frame.bg = nil; frame.bb = nil; frame.balpha = nil
		frame.GetBorderColor = function(self)
			return nil
		end
		frame.GetBorderWidth = function(self)
			return nil
		end
	end
end

function Emlib.setColoredFrame(frame, bkColor, borderColor, borderWidth, alpha, texName) -- modifie un frame
	-- ajoute une texture avec une éventuelle bordure, au FRAME passé (non BUTTON)
	-- renvoit un pointeur vers cette texture
	-- frame.texture et frame.backdrop sont dispos
	
	---- bkColor : couleur du fond (toutes formes acceptées : nom couleur, ou couleur hexa, ou table {r, g, b})
	---- borderColor : couleur de la bordure (toutes formes acceptées : nom couleur, ou couleur hexa, ou table {r, g, b})
	---- alpha : de la texture (n'impacte pas la bordure)
	---- texName : nom de la texture créée ("$parent_tex" par défaut)
	--[[ exemples d'appel :
			local tex = Emlib.setColoredFrame(frame, {0.2, 0.2, 0.8}, nil, 0, 0.8) -- pas de bordure
			local tex = Emlib.setColoredFrame(frame, "#555555", "red", 1, 0.8) -- bordure rouge de 1 px
	--]]
	Emlib.setColoredRegion(frame, bkColor, borderColor, borderWidth, alpha, texName)
end

function Emlib.setColoredButton(frame, bkColor, borderColor, borderWidth, alpha, hilitedAlphaOrColor, texName)
	-- ajoute une texture, et une texture highlight, avec une éventuelle bordure, au BUTTON passé
	-- renvoit un pointeur vers cette texture
	-- frame.texture et frame.backdrop sont dispos
	-- frame.r, frame.g, frame.b (couleurs) et frame.alpha dispos

	---- bkColor : couleur du fond (toutes formes acceptées : nom couleur, ou couleur hexa, ou table {r, g, b})
	---- borderColor : couleur de la bordure (toutes formes acceptées : nom couleur, ou couleur hexa, ou table {r, g, b})
	---- alpha : de la texture (n'impacte pas la bordure)
	---- hilitedAlphaOrColor : couleur hilited (toutes formes acceptées) OU valeur alpha (nombre)
	---- texName : nom de la texture créée ("$parent_tex" par défaut)
	--[[ exemples d'appel :
			Emlib.setColoredButton(button, {0.2, 0.2, 0.8}, nil, 0, 0.8, 0.3) -- pas de bordure et hilite par modif alpha (0.3)
			local tex = Emlib.setColoredButton(button, {0.2, 0.2, 0.8}, "red", 1, 0.8, 0.3) -- bordure rouge de 1 px
			local tex = Emlib.setColoredButton(button, "grey", nil, 0, 0.8, "yellow" -- hilite button jaune
	--]]
	Emlib.setColoredRegion(frame, bkColor, borderColor, borderWidth, alpha, hilitedAlphaOrColor, texName)
end
	
function Emlib.setColoredRegion(frame, bkColor, borderColor, borderWidth, alpha, hilitedAlphaOrColor, texName)
	-- .setColoredButton() ou .setColoredFrame() suivant si FRAME simple ou BUTTON
	-- frame.texture est dispo
	-- DEPENDANCE : .createBorder()
	-- .GetBackgroundColor() ou .r, .g, .b et .alpha dispos
	if (frame ~= nil) then
		local bkColor = bkColor or {0.2, 0.2, 0.9} -- couleur RGB du fond
		bkColor = Emlib.getColor(bkColor, "table")
		local borderColor = borderColor or {0.8, 0.8, 0.3}
		borderColor = Emlib.getColor(borderColor, "table")
		local borderWidth = tonumber(borderWidth) or 0 -- cadre éventuel
		local alpha = tonumber(alpha) or 1 -- alpha de la texture (pas de la bordure !)
		local texName = texName or (Emlib.videSiNul(frame:GetName()).."_tex")
		local borderAlpha = 0.9 -- ///// non géré dans les paramètres de la fcn
		
		------------------------------------------------ fond (création texture RGB)
		if (not frame.texture) then frame.texture = frame:CreateTexture(texName, "BACKGROUND") end
		frame.texture:SetColorTexture(bkColor[1], bkColor[2], bkColor[3], alpha)
		--frame.texture:SetAlpha(alpha) -- répétition pour bug SetColorTexture() ?
		frame.texture:SetAllPoints()

		------------------------------------------------ bordure éventuelle
		if (borderWidth > 0) then Emlib.createBorder(frame, borderWidth, borderColor, borderAlpha) end
		
		------------------------------------------------ création hilite texture (pour bouton seulement)
		if (frame:IsObjectType("Button")) then -- secu
			if (not frame.hitexture) then frame.hitexture = frame:CreateTexture(texName.."HI", "BACKGROUND") end --/////
			local hilitedAlphaOrColor = hilitedAlphaOrColor or 0.4 -- hilite par modif alpha pour un BUTTON
			if (type(hilitedAlphaOrColor) == "number") then
				---------- l'hilite se fera par un changement d'alpha
				frame.hitexture:SetColorTexture(bkColor[1], bkColor[2], bkColor[3], hilitedAlphaOrColor)
				frame.hitexture:SetAlpha(hilitedAlphaOrColor) -- répétition pour bug SetColorTexture() ?
			else
				---------- l'hilite se fera par une nouvelle valeur RGB
				if (type(hilitedAlphaOrColor) ~= "table") then hilitedAlphaOrColor = Emlib.getColor(hilitedAlphaOrColor, "table") end
				frame.hitexture:SetColorTexture(hilitedAlphaOrColor[1], hilitedAlphaOrColor[2], hilitedAlphaOrColor[3], 0.5)
			end
			frame.hitexture:SetAllPoints()
			frame:SetHighlightTexture(frame.hitexture) -- seulement BUTTON
		end
		------------------------------------------------ 
		frame.r = bkColor[1]; frame.g = bkColor[2]; frame.b = bkColor[3]; frame.alpha = alpha
		frame.GetBackgroundColor = function(self)
			return {self.r, self.g, self.b}
		end
		------------------------------------------------
		return frame.texture
	end
end

function Emlib.setTexturedFrame(frame, texName, imagePath, imgCoordH, imgCoordV, alpha, hilitedTexOrValue)
--[[
	créé une TEXTURE par FICHIER IMAGE au frame passé (et renvoit un pointeur vers cette texture)
	texName : nom de texture (si nil, ajout de "Hi")
	imgCoordH et imgCoordV :
		- si pas besoin de décalage de placement : taille de l'image tgs
		- si besoin placement précis : table de coordonnées  {h1, v1} et {v1, v2}
	hilitedAlphaOrRGB (seulement pour les boutons) : texture hilited (autre image ou valeur alpha)
		exemples d'appel :
			local tex = Emlib.setTexturedFrame(myFrame, "myFrame_tex", "Interface\\AddOns\\NPCsMarkers\\stuff\\myPict", 40, 25, 0.8, "Interface\\AddOns\\NPCsMarkers\\stuff\\myPictHI") -- size frame : 40 x 25
			local tex = Emlib.setTexturedFrame(myFrame, nil, "Interface\\AddOns\\NPCsMarkers\\stuff\\myPict", {10, 40}, {0, 30}, 1, 0.3)
--]]
	if (frame ~= nil) then
		local hilitedTexOrValue = hilitedTexOrValue or 0.4
		local alpha = tonumber(alpha) or 1
		local imgCoordsTable = imgCoordsTable or {{0, 1}, {0, 1}}
		local texName = texName or (Emlib.videSiNul(frame:GetName()).."_tex")
		------------------------------------------------- texture image
		-------------- coords V : si imgCoordV est un entier : l'image est calée en 0 (coin haut)
		local imgCoordV = imgCoordV or {0, 1}
		local v1 = 0
		local v2 = 1
		if (type(imgCoordV) == "table") then
			v1 = Emlib.strToNumber(imgCoordV[1])
			v2 = Emlib.strToNumber(imgCoordV[2])
		else
			v2 = Emlib.strToNumber(imgCoordV)
		end
		-------------- coords H : si imgCoordH est un entier : l'image est calée en 0 (coin gauche)
		local imgCoordH = imgCoordH or {0, 1}
		local h1 = 0
		local h2 = 1
		if (type(imgCoordH) == "table") then
			h1 = Emlib.strToNumber(imgCoordH[1])
			h2 = Emlib.strToNumber(imgCoordH[2])
		else
			h2 = Emlib.strToNumber(imgCoordH)
		end
		-------------- calcul taille TGA nécessaire (plus petite taille pour contenir les dimensions passées)
		local tgaWidth = Emlib.getMinTgaSize(h2)
		local tgaHeight = Emlib.getMinTgaSize(v2)
--print("setTexturedFrame()----","h1=",h1,"h2=",h2,"v1=",v1,"v2=",v2,"tgaWidth=",tgaWidth,"tgaHeight=",tgaHeight)--/////
		--------------
		
		------------------------------------------------ fond (création texture RGB)
		if (not frame.texture) then frame.texture = frame:CreateTexture(texName, "BACKGROUND") end
		frame.texture:SetTexture(imagePath)
		frame.texture:SetAllPoints()
		frame.texture:SetTexCoord(h1/tgaWidth, h2/tgaWidth, v1/tgaHeight, v2/tgaHeight)
		frame.texture:SetAlpha(alpha)
		------------------------------------------------- hilite
		if (frame:IsObjectType("Button")) then
			---------- seuls les boutons acceptent un hilite !
			local texNameHi = nil
			if (texName ~= nil) then texNameHi = texName.."HI" end
			local hitexture = frame:CreateTexture(texNameHi, "BACKGROUND")
			
			if (type(hilitedTexOrValue) == "number") then
				---------- l'hilite se fera par un changement d'alpha
				hitexture:SetTexture(imagePath)
				hitexture:SetAlpha(hilitedTexOrValue)
			elseif (type(hilitedTexOrValue) == "string") then
				---------- l'hilite se fera par une autre image
				hitexture:SetTexture(hilitedTexOrValue)
			end
			
			hitexture:SetAllPoints()
			hitexture:SetTexCoord(h1/tgaWidth, h2/tgaWidth, v1/tgaHeight, v2/tgaHeight)
			frame:SetHighlightTexture(hitexture)
		end
		
		return frame.texture
	end
end

function Emlib.getMinTgaSize(texSize)
	local texSize = tonumber(texSize) or 0
	local tgaSize = 0
	for i = 1, 14 do -- increment 1 par defaut
		tgaSize = math.pow(2, i)
		if (tgaSize >= texSize) then
			break
		end
	end
	return tgaSize
end

---------------------------------------------------------------------------------------
------------------------------------------ DEV ----------------------------------------

function Emlib.showHiliteFrame(frame, optionalColor, optionalAlpha) -- colorize un frame pour le visualiser
	if (frame ~= nil) then
		Emlib.setColoredFrame(frame, optionalColor or "blue", "orange", 1, tonumber(optionalAlpha) or 1, nil)
		frame:Show()
	else
		Emlib.echoWindow(".showHiliteFrame(): no frame.", "red", nil)
	end
end

function Emlib.showBackdropsList() -- pour dev : affichage des built-in backdrops
	local tbl = {"BACKDROP_TOOLTIP_8_8_1111", "BACKDROP_TOOLTIP_8_12_1111", "BACKDROP_TOOLTIP_16_16_5555", "BACKDROP_TOOLTIP_12_12_4444", "BACKDROP_TOOLTIP_0_16", "BACKDROP_TOOLTIP_0_12_0055", "BACKDROP_TOOLTIP_0_16_5555", "BACKDROP_ACHIEVEMENTS_0_64", "BACKDROP_ARENA_32_32", "BACKDROP_DIALOG_32_32", "BACKDROP_GOLD_DIALOG_32_32", "BACKDROP_WATERMARK_DIALOG_0_16", "BACKDROP_SLIDER_8_8", "BACKDROP_PARTY_32_32", "BACKDROP_TOAST_12_12", "BACKDROP_CALLOUT_GLOW_0_1", "BACKDROP_CALLOUT_GLOW_0_20", "BACKDROP_GLUE_TOOLTIP_16_16", "BACKDROP_GLUE_TOOLTIP_0_16", "BACKDROP_MIXED_TOOLTIP_16_16", "BACKDROP_TEXT_PANEL_0_16", "", "", "", ""}
	
	local largeur, hauteur, marge = 210, 70, 15
	
	local h, v = 10, -10
	local maxH, maxV = UIParent:GetWidth(), UIParent:GetHeight()
	local frame, str
	for i, value in ipairs(tbl) do
		if (value ~= "") then
			frame = CreateFrame("Frame", "frameTest_"..i, UIParent)
			frame:SetSize(largeur, hauteur)
			frame:SetPoint("TOPLEFT", "$parent", "TOPLEFT", h, v)
			-------------- backdrop
			frame.texture = frame:CreateTexture(frame:GetName().."_tex", "BACKGROUND")
			--frame.texture:SetColorTexture(bkColor[1], bkColor[2], bkColor[3], alpha)
			frame.texture:SetAllPoints()
			if (not frame.SetBackdrop) then Mixin(frame, BackdropTemplateMixin) end
			frame:SetBackdrop(_G[value])
			-------------- texte
			str = frame:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormalSmall")
			str:SetFont("Interface\\AddOns\\CmdLine\\stuff\\Myriad Condensed Web.ttf", 11, "NONE") --/////
			str:SetPoint("CENTER", 1, 0)
			str:SetText(tostring(value))
			str:SetJustifyH("CENTER")
			-------------- placement
			h = h + largeur + marge
			if (h + largeur > maxH) then
				h = 10
				v = v - hauteur - marge
			end
			if (math.abs(v) + hauteur > maxV) then
				print("showBackdropsList(): not enough height:", #(tbl) - i, "frames left")
				break
			end
		end
	end
end

---------------------------------------------------------------------------------------
--------------------------------------- ECHOTAGE --------------------------------------

function Emlib.getTxtColor(str, color)
	-- renvoit la chaine passée formatté avec la couleur passée (tout format de couleur accepté, "SYSTEM" par défaut)
	if (str == nil or str == "") then
		return ""
	else
		return ("|cFF"..Emlib.getColor(color, "hexa")..str.."|r")
	end
end

function Emlib.echoWindow(str, color, chatWindowName)
	-- affiche la chaine passée (nouveau nom pour rétro-compatibilité)
	-- chatWindowName : nom chat optionnel (si omis, la 1ere fenetre de chat visible et valide sera utilisée).
	-- chatWindowName : ATTENTION : si cette fenetre existe, elle sera utilisée, même si pas au 1er plan !!!
	-- color : tout format de couleur accepté, "grey" si omis
	
	local color = color or "grey"
	local r, g, b = Emlib.getColor(color, "rgb")
	------------------ recherche index (indexChatFrame) de la fenetre de chat correspondant au nom passé
	local indexChatFrame = 0
	if (chatWindowName ~= nil and chatWindowName ~= "") then
		indexChatFrame = Emlib.getIndexChatWindow(chatWindowName) -- 0 si non existe
	else
		indexChatFrame = Emlib.getIndexFistVisibleChatWindow()
	end
	------------------ affichage (dans DEFAULT si indexChatFrame == 0)
	if (indexChatFrame == 0) then indexChatFrame = DEFAULT_CHAT_FRAME:GetID() end
	_G["ChatFrame"..indexChatFrame]:AddMessage(str, r, g, b, ChatTypeInfo["SYSTEM"])
end
function Emlib.echo(chaine, color, nomChat) -- raccourci et rétro-compatibilité
	local chatWindowName = nomChat or nil
	Emlib.echoWindow(chaine, color, chatWindowName)
--[[
	local tblChat = ChatTypeInfo["SYSTEM"]
	if (DEFAULT_CHAT_FRAME) then ChatFrame1:AddMessage(chaine, tblChat["r"] , tblChat["g"], tblChat["b"]); end;
--]]
end
function Emlib.echoChat(str, color, allWindows) -- pour rétro-compatibilité
	-- affiche le message passé dans la 1ere fenetre de chat VISIBLE
	Emlib.echoWindow(str, color, nil)
end

function Emlib.getIndexChatWindow(chatWindowName) -- renvoit l'index de la fenetre de chat passée (ou 0 si n'existe pas)
	local indexChatFrame = 0
	for i = 1, NUM_CHAT_WINDOWS, 1 do
		local name, fontSize, r, g, b, alpha, shown = GetChatWindowInfo(i)
--print("name",i,name, shown)--/////
		if (name == chatWindowName) then
			indexChatFrame = i
			break
		end
	end
	return indexChatFrame
end

function Emlib.getIndexFistVisibleChatWindow() -- renvoit l'index de la 1ere fenetre de chat visible (ou 0)
	local indexChatFrame = 0
	for i = 1, NUM_CHAT_WINDOWS, 1 do
		local name, fontSize, r, g, b, alpha, shown = GetChatWindowInfo(i)
--print("visible", i,name, shown)--/////
		if (shown) then
			indexChatFrame = i
			break
		end
	end
	return indexChatFrame
end

function Emlib.echoDebug(value, commStr)
	if (commStr == nil) then
		commStr = "DEBUG "
	else
		commStr = commStr.." "
	end
	
	--if (Emlib.isTrue(value)) then
	local varType = type(value)
	if (varType == "nil") then
		Emlib.echo(commStr.."|cFFFF8040NIL")
	elseif (varType == "table") then
		Emlib.echoTable(value, commStr, false, "")
	elseif (varType == "string") then
		Emlib.echo(commStr.."STRING=|cFFFF8040"..value)
	elseif (varType == "number") then
		Emlib.echo(commStr.."NUMBER=|cFFFF8040"..value)
	elseif (varType == "boolean") then
		Emlib.echo(commStr.."BOOLEAN=|cFFFF8040"..Emlib.booleanToStr(value))
	else
		Emlib.echo(commStr.."UNKNOWN_TYPE=|cFFFF8040"..Emlib.nilSiNul(varType))
	end
end

function Emlib.echoTable(tbl, commStr, niveauUniqueBoolean, prefixeStr, nivIndent)
	-- echo recursif de table (pour debug)
	if (commStr == nil) then commStr = "DEBUG TABLE"; end;
	if (tbl == nil) then
		Emlib.echo(commStr.."|cFFEDDDC0---NIL");
	elseif next(tbl) == nil then -- attention : #tbl renvoit toujours 0
		Emlib.echo(commStr.."|cFFEDDDC0---EMPTY");
	else
		if (niveauUniqueBoolean == nil) then niveauUniqueBoolean = false; end;
		if (prefixeStr == nil) then prefixeStr = ""; end;
		if (nivIndent == nil) then
			nivIndent = 0;
		else
			nivIndent = Emlib.strToNumber(nivIndent); -- fcn perso
		end;
		
		if (nivIndent == 0) then Emlib.echo("|cFFEDDDC0---"..commStr); end;
		for key, value in pairs(tbl) do
			if (type(value) == "table") then
				if (niveauUniqueBoolean) then
					Emlib.echo("|cFFEDDDC0"..prefixeStr.."|cFF60B599["..key.."]|cFFEDDDC0".."-----TABLE");
				else
					Emlib.echo("|cFFEDDDC0"..prefixeStr.."|cFF60B599["..key.."]|cFFEDDDC0");
					local indentStr = "";
					for i = 0,nivIndent,1 do
						indentStr = indentStr.."   ";
					end;
					Emlib.echoTable(value, commStr, niveauUniqueBoolean, prefixeStr..indentStr, nivIndent + 1);
				end;
			else
				Emlib.echo("|cFFEDDDC0"..prefixeStr.."|cFF60B599["..key.."]|cFFEDDDC0"..tostring(value).."---");
			end;
		end;
	end;
end